/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Meshing3D.h"

/* Meshing meshes the geometry if requested and reads the mesh.
 * At the end of Meshing, one gets the mesh and the fods, either
 * from the mesh we just built or a msh file to convert.
 */
void
GeoMeshing3D (struct IN In, struct NODES *pNodes,
	      struct MESH *pMesh2D, struct MESH *pMesh3D)
{
  char *Args = ut_alloc_1d_char (1000);
  struct MESH TrashMesh0, TrashMesh1;	/* trash meshes. */
  FILE *msh;

  /*LineHeader(0); printf("Meshing geometry... [%s]\n",In.gmsh); */

  if (In.input == 0)
    sprintf (Args, "-3 -v 0 %s -order %d -o %s", In.geo, In.morder, In.msh);
  else if (In.input == 1)
    sprintf (Args, "-3 -v 0 %s -order %d -o %s", In.restart, In.morder, In.msh);
  else
    abort ();

  neut_gmsh_call (In.gmsh, Args);

  ut_free_1d_char (Args);

  /* ut_print_message(0,"Meshed geometry...\n"); */

  /* Reading mesh */
  if (ut_string_inlist (In.format, ',', "msh") == 1)
    msh = OpenFile (In.msh, "r");
  else
    msh = OpenFile (In.msh, "R");

  ReadMsh (pNodes, &TrashMesh0, &TrashMesh1, pMesh2D, pMesh3D, msh);

  if (ut_string_inlist (In.format, ',', "msh") == 1)
    CloseFile (msh, In.msh, "r");
  else
    CloseFile (msh, In.msh, "R");

  Check3DMesh (*pMesh3D);

  return;
}
