#include "ReadMesh.h"

void
ReadMesh (struct IN In, struct NODES* pNodes, struct MESH* pMesh0D,\
          struct MESH* pMesh1D, struct MESH* pMesh2D, struct MESH* pMesh3D)
{
  FILE *file;
  FILE *file2;
  FILE *file3;
  char *parms, *mesh, *opt;

  if (In.input == 2)
  {
    file = OpenFile (In.restart, "r");
    ReadMsh (pNodes, pMesh0D, pMesh1D, pMesh2D, pMesh3D, file);
    CloseFile (file, In.restart, "r");
  }
  else if (In.input == 3)
  {
    file = OpenFile (In.restart, "r");
    neut_mesh_fscanf (file, "geof", pNodes, pMesh3D);
    CloseFile (file, In.restart, "r");
  }
  else if (In.input == 4)
  {
    parms = ut_alloc_1d_char (strlen (In.restart) + 8);
    parms = ut_string_addextension (In.restart, ".mae1");
    if (ut_file_exist (parms) == 0)
    {
      parms = ut_string_addextension (In.restart, ".parms");
      if (ut_file_exist (parms) == 0)
	ut_print_message (2, "no .mae1 or .parms file found.\n");
      abort ();
    }
    mesh  = ut_alloc_1d_char (strlen (In.restart) + 8);
    mesh = ut_string_addextension (In.restart, ".mae2");
    if (ut_file_exist (mesh) == 0)
    {
      parms = ut_string_addextension (In.restart, ".mesh");
      if (ut_file_exist (parms) == 0)
	ut_print_message (2, "no .mae2 or .mesh file found.\n");
      abort ();
    }
    opt  = ut_alloc_1d_char (strlen (In.restart) + 8);
    opt = ut_string_addextension (In.restart, ".mae4");
    if (ut_file_exist (opt) == 0)
    {
      opt = ut_string_addextension (In.restart, ".opt");
      if (ut_file_exist (opt) == 0)
	ut_print_message (2, "no .mae4 or .opt file found.\n");
      abort ();
    }

    file = ut_file_open (parms, "r");
    file2 = ut_file_open (mesh, "r");
    file3 = ut_file_open (opt, "r");
    neut_maemesh_fscanf (file, file2, file3, pNodes, pMesh3D);
    ut_file_close (file, parms, "r");
    ut_file_close (file2, mesh, "r");
    ut_file_close (file, opt, "r");
    
    ut_free_1d_char (parms);
    ut_free_1d_char (mesh);
    ut_free_1d_char (opt);
  }

  return;
}
