/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "SearchNSets.h"

void
SearchNSets (int input, struct NODES Nodes, struct MESH Mesh2D, int nset,
             char* fodfile, int *** pFoDNodes, int*** pFoDBNodes,
	     int*** pEoDNodes, int*** pEoDBNodes, int*** pCoDNodes)
{
  FILE* file;
  int** FoD;

  if (nset > 0)
  {
    if (ut_file_exist (fodfile) && input <= 2)
    {
      file = ut_file_open (fodfile, "r");
      neut_fod_fscanf (file, &FoD);
      ut_file_close (file, fodfile, "r");

      neut_fod_fodnodes (FoD, Mesh2D, pFoDNodes);
    }
    else
    {
      ut_print_messagewnc (1, 72, "File .fod not found and / or nsets not available in input files.  Assuming brick shape of the domain to determine nsets."); 
      neut_nodes_fodnodes (Nodes, pFoDNodes);
    }
  }

  if (nset <= 0)
    return;

  if (nset >= 2)
  {
    neut_fodnodes_eodnodes (*pFoDNodes, pEoDNodes);
    neut_eodnodes_codnodes (*pEoDNodes, pCoDNodes);
  }
  if (nset >= 3)
  {
    neut_fodnodes_fodbnodes (*pFoDNodes, *pEoDNodes, pFoDBNodes);
    neut_eodnodes_eodbnodes (*pEoDNodes, *pCoDNodes, pEoDBNodes);
  }

  ut_free_2d_int (FoD, 7);

  return;
}
