/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"WriteMesh.h"

void
WriteMesh (struct IN In, struct GEO Geo, struct NODES Nodes,
	   struct MESH Mesh2D, struct MESH Mesh3D, char *format)
{
  FILE *file;
  char command[1000];
  int **FoD;
  int** FoDNodes, **FoDBNodes, **EoDNodes, **EoDBNodes, **CoDNodes;

  SearchNSets (In.input, Nodes, Mesh2D, In.nset, In.fod, &FoDNodes, &FoDBNodes,
      &EoDNodes, &EoDBNodes, &CoDNodes);

  file = ut_file_open (In.fod, "r");
  neut_fod_fscanf (file, &FoD);
  ut_file_close (file, In.fod, "r");

  if (strcmp (format, "geof") == 0)
  {
    file = ut_file_open (In.geof, "w");
    WriteMeshGeof (file, Geo, FoD, Nodes, Mesh2D, Mesh3D, In.nset,
	In.nsetlist, FoDNodes, FoDBNodes, EoDNodes, EoDBNodes, CoDNodes,
	In.liset);
    ut_file_close (file, In.geof, "w");
    
    /* optionally, renaming geo to geob */
    if (In.geo2geob == 1 && ut_file_exist (In.geo))
    {
      sprintf (command, "mv %s %s", In.geo, In.geob);
      system (command);
    }
  }
  else if (strcmp (format, "mae") == 0)
  {
    WriteMeshMae (In, FoD, Nodes, Mesh2D, Mesh3D, In.nset,
	In.nsetlist, FoDNodes, FoDBNodes, EoDNodes, EoDBNodes, CoDNodes);
  }

  return;
}
