/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"WriteMeshMae.h"

void
WriteMeshMae (struct IN In, int **FoD, struct NODES Nodes,
	      struct MESH Mesh2D, struct MESH Mesh3D, int nset, char *nsetlist,
	      int **FoDNodes, int **FoDBNodes, int **EoDNodes,
	      int **EoDBNodes, int **CoDNodes)
{
  FILE *file;

  file = ut_file_open (In.mae1, "w");
  neut_mesh_fprintf_mae_parms (file, Nodes, Mesh3D);
  ut_file_close (file, In.mae1, "w");

  /* mae2 = connectivity and geometry */
  file = ut_file_open (In.mae2, "w");

  neut_mesh_fprintf_mae_elts (file, Mesh3D, FoD);
  fprintf (file, "  1.0   1.0   1.0\n");
  neut_mesh_fprintf_mae_nodes (file, Nodes);
  ut_file_close (file, In.mae2, "w");

  /* mae3 = connectivity at the surface (2D elements) */
  file = ut_file_open (In.mae3, "w");
  neut_mesh_fprintf_mae_skinelts (file, Mesh2D, Mesh3D, Nodes, FoD);
  ut_file_close (file, In.mae3, "w");

  /* mae4 = element sets */
  file = ut_file_open (In.mae4, "w");
  neut_mesh_fprintf_mae_elsets (file, Mesh3D);
  ut_file_close (file, In.mae4, "w");

  /* mae5 = nsets (file .bcs) */
  file = ut_file_open (In.mae5, "w");
  neut_mesh_fprintf_mae_nsets (file, nset, nsetlist, FoDNodes,
				FoDBNodes, EoDNodes, EoDBNodes, CoDNodes);
  ut_file_close (file, In.mae5, "w");

  return;
}
