/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#ifndef STRUCTIN_H
#define STRUCTIN_H

struct IN
{
  int verbosity;
  char *gmsh;

  /* FILE NAMES */
  int input;			/* input: 0 = tess, 1 = geo, 2 = msh, 3 = geof */

  char *tess;			/* tess  file name (input tessellation) */

  /* GENERALITIES ON THE GEO */
  int newver;			/* how to position the new vertices? */
  int edgedis;			/* discretize the edges with neper?  */

  /* FFFS */
  int ffalgo;			/* this is for non-planar faces */
  int mloop;

  /* DEBUGGING STUFF */
  int delstop;			/* this is for debugging */

  /* MESH */
  int morder;

  char *format;			/* geo, msh, geof and/or mae */
  int maeextension;		/* 0: extension mae#, 1: parms,... */
  int meshalgorithm;		/* 1: isotropic, 2: anisotropic, 3: triangle */

  int nset;			/* list the nset: none (0), faces (1) */
  char *nsetlist;		/* list of nsets (sep by ',') if nset = 0 */

  /* operation to do */
  int renumber;
  int renumberpartitionqty;
  int tess2geo;
  int mesh;			/* to mesh from a geo file */
  int geo2geob;
  int meshimprovement2d;
  int nodefirstid;		/* -1: default, then whatever */
  int eltfirstid;		/* -1: default, then whatever */

  char *body;
  char *geo;
  char *geob;
  char *ff;			/* ff    file name (flatness faults  ) */
  char *edgel;
  int printedgel;		/* edgel file name (edge lengths     ) */
  char *angle;
  int printangle;		/* angle file name (geo angles       ) */
  char *restart;
  char *msh;
  char *geof;
  char *mae1;
  char *mae2;
  char *mae3;
  char *mae4;
  char *mae5;
  char *estat;
  int printestat;		/* if =1: printing element statistics  */
  char *eangle;
  int printeangle;		/* if =1: printing element angles      */
  char *nstat;
  int printnstat;		/* if =1: printing node statistics  */
  char *fod;
  int printfod;
  int liset;
  char *oin;
  int print;
  char *printformat;
  int *printfaces;
  char *mast;
  char *asy;
};
typedef struct IN IN;

#endif /* STRUCTIN_H */
