/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_o.h"

void
TreatArg_o (int fargc, char **fargv, int argc, char **argv,
	    struct ORI *pOri, struct IN *pIn)
{
  char *body;
  int inibody = 0;

  int iniN = 0;			/* 1 if N is initialized. */
  int inioin = 0;		/* 1 if oin is initialized. */

  SetDefaultOptions_o (pOri, pIn);

  /* Reading options */
  SetOptions_o (pOri, pIn, &body, &inibody, &iniN, &inioin, fargc, fargv);
  SetOptions_o (pOri, pIn, &body, &inibody, &iniN, &inioin, argc, argv);

  /* Testing options */
  if ((iniN == 0 && inioin == 0) || (iniN == 1 && inioin == 1))
    BadArguments ();

  if (strcmp ((*pIn).econv, "bunge") != 0 &&
      strcmp ((*pIn).econv, "roe") != 0 &&
      strcmp ((*pIn).econv, "kocks") != 0)
    ut_arg_error ("-euleranglesconvention",
		  "Unknown Euler angles convention.  Valid possibilities are: bunge, roe and kocks.");

  /* Writing file names */

  if (inibody == 0)
  {
    body = oneDCharDAlloc (1000);

    if ((iniN == 1) && ((*pOri).id != -1))
      sprintf (body, "n%d-id%d", (*pOri).N, (*pOri).id);
    else if ((iniN == 1) && ((*pOri).id == -1))
      sprintf (body, "n%d-rand", (*pOri).N);
    else
      body = GiveBody ((*pOri).oin);
  }

  (*pIn).ori = AddExtension (body, ".ori");

  if (inibody == 0)
    oneDCharFree (body);

  return;
}
