/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_o.h"

void
WriteOri (struct ORI Ori, char *format, FILE * file)
{
  int i, j;

  if (strcmp (format, "plain") == 0)
    ut_board_2d_fprintf (file, Ori.angle + 1, Ori.N, 3, "%16.12f");
  else if (strcmp (format, "mae") == 0)
  {
    fprintf (file, "grain-orientations\n%d\n", Ori.N);
    for (i = 1; i <= Ori.N; i++)
    {
      for (j = 0; j < 3; j++)
	fprintf (file, "%14.10f ", Ori.angle[i][j]);
      fprintf (file, "%d\n", i);
    }
    fprintf (file, "EOF\n");
  }
  else if (strcmp (format, "geof") == 0)
    for (i = 1; i <= Ori.N; i++)
    {
      fprintf (file, "**elset poly%d  *rotation ", i);
      for (j = 0; j < 3; j++)
	fprintf (file, "%16.12f ", Ori.angle[i][j]);
      fprintf (file, "\n");
    }

  return;
}
