/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_t.h"

void
TreatArg_t (int fargc, char **fargv, int argc, char **argv,
	    struct IN *pIn, struct GERMSET *pGermSet)
{
  int inibody = 0;

  SetDefaultOptions_t (pIn, pGermSet);

  /* Reading options */
  SetOptions_t (pIn, pGermSet, &((*pIn).body), &inibody, fargc, fargv);
  SetOptions_t (pIn, pGermSet, &((*pIn).body), &inibody, argc, argv);

  /* Testing options */
  if ((*pIn).input == -1)
  {
    ut_print_message (2, "missing input data.");
    abort ();
  }

  if ((*pIn).input == 0 && (*pGermSet).Id == -1)
    MessageWNC (1, 72,
		"The identifier (-id) has not been specified; considering a random value...");

  /* Writing file names */

  if (inibody == 0)
  {
    (*pIn).body = ut_alloc_1d_char (1000);

    if ((*pIn).input == 0)
    {
      if ((*pGermSet).Id != -1)
	sprintf ((*pIn).body, "n%d-id%d", (*pGermSet).N, (*pGermSet).Id);
      else
	sprintf ((*pIn).body, "n%d-rand", (*pGermSet).N);
    }
    else if ((*pIn).input == 1)
    {
      (*pIn).body = ut_alloc_1d_char (strlen ((*pIn).restart));
      (*pIn).body = ut_string_body ((*pIn).restart);
    }
    else
      abort ();
  }

  (*pIn).tess = AddExtension ((*pIn).body, ".tess");
  (*pIn).vcoo = AddExtension ((*pIn).body, ".vcoo");
  (*pIn).mast = AddExtension ((*pIn).body, ".mast");
  (*pIn).asy = AddExtension ((*pIn).body, ".asy");

  if ((*pIn).printpointpoly == 1)
    (*pIn).polyid = AddExtension ((*pIn).point, ".polyid");
  else if ((*pIn).printpointpoly == 2)
    (*pIn).polyid = AddExtension ((*pIn).point, "-centre.polyid");

  return;
}
