/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_t.h"

extern void
Res_t (struct IN In, struct TESS Tess)
{
  FILE *ExportFile;
  struct GEO Geo;
  int i, qty;
  char **parts;
  int *FaceList, *EdgeList, *VerList;
  char *name = ut_alloc_1d_char (1000);

  ExportFile = OpenFile (In.tess, "w");
  TessExport (Tess, ExportFile);
  CloseFile (ExportFile, In.tess, "w");

  if (In.vcoocalc == 1)
  {
    ExportFile = OpenFile (In.vcoo, "w");
    VerCoo (Tess, ExportFile);
    CloseFile (ExportFile, In.vcoo, "w");
  }

  if (In.print > 0)
  {
    Tess2Geo (Tess, &Geo);
    if (strlen (In.printformat) > 0)
    {
      ut_string_separate (In.printformat, ',', &parts, &qty);
      PrintGeoStuff (In.print, In.printfaces, Geo, &FaceList, &EdgeList,
		     &VerList);
      for (i = 0; i < qty; i++)
      {
	sprintf (name, "%s-print", In.body);
	name = ut_string_addextension (name, parts[i]);
	PrintGeoAsImg (Geo, EdgeList, VerList, parts[i], name);
      }
    }
  }

  if (In.printpointpoly)
    PrintPointPoly (In, Tess);

  ut_free_1d_char (name);

  return;
}
