#include"neut_debug.h"

void
neut_debug_nodes (FILE* file, struct NODES Nodes)
{
  fprintf (file, "====== Beginning of Nodes ================================\n");
  fprintf (file, "Nodes:\n");
  fprintf (file, "NodeQty = %d\n", Nodes.NodeQty);

  if (Nodes.NodeQty > 0)
  {
    fprintf (file, "NodesNbMax = %d\n", Nodes.NodeNbMax);
    fprintf (file, "NodesNb[1-%d] = ", Nodes.NodeQty);
    ut_board_1d_int_fprintf (file, Nodes.NodesNb + 1, Nodes.NodeQty, "%d");
    fprintf (file, "NodesNbInv[0-%d] = ", Nodes.NodeNbMax);
    ut_board_1d_int_fprintf (file, Nodes.NodesNbInv, Nodes.NodeNbMax + 1, "%d");
    fprintf (file, "NodesCoo = %d\n", Nodes.NodeNbMax);
    ut_board_2d_fprintf (file, Nodes.NodesCoo + 1, Nodes.NodeQty, 3, "%f");
  }
  
  fprintf (file, "====== End of Nodes ======================================\n");
  return;
  
  return;
}

void
neut_debug_mesh (FILE* file, struct MESH Mesh)
{
  int i;
  int eltnodeqty = neut_elt_nodeqty ("tri", Mesh.Dimension, Mesh.EltOrder);

  fprintf (file, "====== Beginning of Mesh =================================\n");
  fprintf (file, "Mesh:\n");
  fprintf (file, "Dimension = %d\n", Mesh.Dimension);
  fprintf (file, "EltOrder = %d\n", Mesh.EltOrder);
  fprintf (file, "EltQty = %d\n", Mesh.EltQty);
  fprintf (file, "(EltQty4Alloc = %d)\n", Mesh.EltQty4Alloc);
  if (Mesh.EltQty > 0)
  {
    fprintf (file, "EltNb[1-%d] = ", Mesh.EltQty);
    ut_board_1d_int_fprintf (file, Mesh.EltNb + 1, Mesh.EltQty, "%d");
    fprintf (file, "EltNbMax = %d\n", Mesh.EltNbMax);
    fprintf (file, "EltNbInv[0-%d] = ", Mesh.EltNbMax);
    ut_board_1d_int_fprintf (file, Mesh.EltNbInv, Mesh.EltNbMax + 1, "%d");
    fprintf (file, "EltNodes = \n");
    ut_board_2d_int_fprintf (file, Mesh.EltNodes + 1, Mesh.EltQty, eltnodeqty, "%d");
    fprintf (file, "ElsetQty = %d\n", Mesh.ElsetQty);
    fprintf (file, "ElsetNb = ");
    ut_board_1d_int_fprintf (file, Mesh.ElsetNb + 1, Mesh.ElsetQty, "%d");
    fprintf (file, "ElsetNbMax = %d\n", Mesh.ElsetNbMax);
    fprintf (file, "ElsetNbInv[1-%d] = ", Mesh.ElsetNbMax);
    ut_board_1d_int_fprintf (file, Mesh.ElsetNbInv + 1, Mesh.ElsetNbMax, "%d");
    fprintf (file, "Elsets = (quantity then ids of elements)\n");
    for (i = 1; i <= Mesh.ElsetQty; i++)
      ut_board_1d_int_fprintf (file, Mesh.Elsets[i], Mesh.Elsets[i][0] + 1, "%d");
  }

  fprintf (file, "====== End of Mesh =======================================\n");
  return;
}

void
neut_debug_fod (FILE* file, int** FoD)
{
  int i;

  fprintf (file, "====== Beginning of FoD ==================================\n");
  fprintf (file, "FoD = (quantity then ids of faces)\n");
  for (i = 1; i <= 6; i++)
    ut_board_1d_int_fprintf (stdout, FoD[i], FoD[i][0] + 1, "%d");

  fprintf (file, "====== End of FoD ========================================\n");

  return;
}

void
neut_debug_fodnodes (FILE* file, int** FoDNodes)
{
  int i;

  fprintf (file, "====== Beginning of FoDNodes =============================\n");
  fprintf (file, "FoDNodes = (quantity then ids of faces)\n");
  for (i = 1; i <= 6; i++)
    ut_board_1d_int_fprintf (stdout, FoDNodes[i], FoDNodes[i][0] + 1, "%d");

  fprintf (file, "====== End of FoDNodes ===================================\n");

  return;
}
