#include "neut_fod.h"

int
neut_fod_fscanf (FILE * file, int ***pFoD)
{
  int i, j, tmp, size, res = -1;

  (*pFoD) = ut_alloc_1d_pint (7);
  for (i = 1; i <= 6; i++)
  {
    fscanf (file, "%d%d", &tmp, &size);
    (*pFoD)[tmp] = ut_alloc_1d_int (size + 1);
    (*pFoD)[tmp][0] = size;
    for (j = 1; j <= (*pFoD)[tmp][0]; j++)
      res = fscanf (file, "%d", &(*pFoD)[tmp][j]);
  }

  return res;
}

void
neut_fod_fodnodes (int **FoD, struct MESH Mesh2D, int ***pFoDNodes)
{
  int i, j, nbnodes;
  int **FaceNodes;

  (*pFoDNodes) = ut_alloc_1d_pint (7);

  for (i = 1; i <= 6; i++)
  {
    FaceNodes = ut_alloc_1d_pint (FoD[i][0] + 1);

    nbnodes = 0;
    for (j = 1; j <= FoD[i][0]; j++)
    {
      /* neut_mesh_elsetnodes should be equivalent */
      ThisFaceNodes (Mesh2D, FoD[i][j], &(FaceNodes[j]));
      nbnodes += FaceNodes[j][0];
    }

    (*pFoDNodes)[i] = ut_alloc_1d_int (nbnodes + 1);

    for (j = 1; j <= FoD[i][0]; j++)
    {
      oneDIntCpy (FaceNodes[j], 1, FaceNodes[j][0], (*pFoDNodes)[i],
		  (*pFoDNodes)[i][0] + 1, 0);
      (*pFoDNodes)[i][0] += FaceNodes[j][0];
    }

    oneDIntSort ((*pFoDNodes)[i], 1, (*pFoDNodes)[i][0]);
    (*pFoDNodes)[i][0] =
      oneDIntCompress ((*pFoDNodes)[i], 1, (*pFoDNodes)[i][0]);

    twoDIntFree (FaceNodes, FoD[i][0] + 1);
  }

  return;
}
