#include "neut_mesh_renumber.h"

void
neut_nodes_switch (struct NODES *pNodes, int n1, int n2)
{
  int n1inv, n2inv;
  double* coo = ut_alloc_1d (3);

  n1inv = (*pNodes).NodesNbInv[n1];
  n2inv = (*pNodes).NodesNbInv[n2];

  ut_board_1d_int_exchange ((*pNodes).NodesNbInv, n1, n2);
  ut_board_1d_int_exchange ((*pNodes).NodesNb, n1inv, n2inv);
  ut_board_2d_exchangelines ((*pNodes).NodesCoo, 3, n1inv, n2inv);

  ut_free_1d (coo);

  return;
}

void
neut_mesh_switch (struct MESH *pMesh, int n1, int n2)
{
  int n1inv, n2inv;
  double* coo = ut_alloc_1d (3);
  int eltnodeqty = neut_elt_nodeqty ("tri", (*pMesh).Dimension, (*pMesh).EltOrder);

  n1inv = (*pMesh).EltNbInv[n1];
  n2inv = (*pMesh).EltNbInv[n2];

  ut_board_1d_int_exchange ((*pMesh).EltNbInv, n1, n2);
  ut_board_1d_int_exchange ((*pMesh).EltNb, n1inv, n2inv);
  ut_board_2d_int_exchangelines ((*pMesh).EltNodes, eltnodeqty, n1inv, n2inv);

  ut_free_1d (coo);

  return;
}
