#include"neut_mmesh.h"

void
neut_mmesh_scale (struct MAPMESH *pMMesh, double scalex, double scaley,
		  double scalez)
{
  int i;
  int qty =
    (*pMMesh).MeshSize[0] * (*pMMesh).MeshSize[1] * (*pMMesh).MeshSize[2];

  for (i = 1; i <= qty; i++)
  {
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 0,
			  scalex * gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 0));
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 1,
			  scaley * gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 1));
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 2,
			  scalez * gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 2));
  }

  return;
}

void
neut_mmesh_shift (struct MAPMESH *pMMesh, double shiftx, double shifty,
		  double shiftz)
{
  int i;
  int qty =
    (*pMMesh).MeshSize[0] * (*pMMesh).MeshSize[1] * (*pMMesh).MeshSize[2];

  for (i = 1; i <= qty; i++)
  {
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 0,
			  shiftx + gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 0));
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 1,
			  shifty + gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 1));
    gsl_matrix_float_set ((*pMMesh).EltCoo, i, 2,
			  shiftz + gsl_matrix_float_get ((*pMMesh).EltCoo, i,
							 2));
  }

  return;
}
