#include "neut_tess.h"

void
neut_tess_boundingbox (struct TESS Tess, double** size)
{
  int i, j, ver;

  /* Searching the tessellation bounding box */
  size[0][0] = size[1][0] = size[2][0] = 1e32;
  size[0][1] = size[1][1] = size[2][1] = -1e32;

  for (i = 0; i < 8; i++)
  {
    ver = Tess.VerOfDomain[i];
    for (j = 0; j < 3; j++)
    {
      size[j][0] = ut_num_min (size[j][0], Tess.VerCoo[ver][j]);
      size[j][1] = ut_num_max (size[j][1], Tess.VerCoo[ver][j]);
    }
  }

  return;
}
